''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'''                                                                    '''
''' STUPID LITTLE COMPILER     *** released to the public domain ***   '''
'''                                                                    '''
''' By Rowan Crowe, released Monday 28-Dec-1998                        '''
'''   rowan@sensation.net.au                                           '''
'''   3:635/728.1@fidonet                                              '''
'''                                                                    '''
''' This is a very simple compiler which is designed to be flexible    '''
''' by having only a limited set of statements. This version is also   '''
''' very simple as it's a bootstrap - the compiler will be rewritten   '''
''' in the new language and then all of the fancy features will be     '''
''' added into that version. This version has unoptimized but valid    '''
''' code generation. See example files for statements and structure.   '''
'''                                                                    '''
''' NOTE: this is work in progress! As of the first release it's only  '''
''' for curiosity value - it's fairly useless as there are no library  '''
''' routines yet.                                                      '''
'''                                                                    '''
''' Requires MoonRock compiler v0.50 or higher:                        '''
'''   http://www.rowan.sensation.net.au/moonrock.html                  '''
'''                                                                    '''
'''   MRC slc                                                          '''
'''       or                                                           '''
'''   MRC slc !DEBUG                                                   '''
'''                                                                    '''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


begin def

stack 8k

%BPLIMIT = 256        ' max number of discrete elements per line
dim bp$[%BPLIMIT]
dim bpt%[%BPLIMIT]
dim bpi%[%BPLIMIT]

%STACKLIMIT = 100
dim stk%[%STACKLIMIT]
dim stklabelstart%[%STACKLIMIT]
dim stklabelend%[%STACKLIMIT]
dim stkp$[%STACKLIMIT]

set =1, %STK_IF, %STK_REPEAT, %STK_WHILE, %STK_FUNCTION

set =1, %VAR_NONE, %VAR_LOCAL, %VAR_FUNCPARM, %VAR_GLOBAL

%OPERATOR = 1         ' + - / * < = > & ! |
%VARIABLE = 2         ' variable
%BRACKET_OPEN = 3     ' (
%COMMA = 4
%FUNCTION = 5         ' function()
%NUMBER = 6           ' decimal number
%ARRAY_BRACKET = 7    ' [ ]
%POINTER = 8          ' *pointer
%KEYWORD = 9          ' <keywords>
%OPENBRACE = 10       ' {
%CLOSEBRACE = 11      ' }
%BRACKET_CLOSE = 12   ' )
%STRING_CONSTANT = 13 ' "something"
%COMMENT = 14         ' # comment

common bpp%, bpptr%, negflag%, locallabel%, jumplabel%, strconstlabel%, ihandle%, ohandle%
common curline%, curline$, stkptr%, braceptr%, vartype%
common funclabelend%
common localvartable$, globalvartable$, strconstbuf$
common tw$, t$    ' hack to prevent memory leaks

bundle thisline valdef%, global%

sub Parse(l$)
sub Evaluate(l$)
sub Logical
sub Compare
sub AddSubtract
sub DivideMultiply
sub Bracket

sub wo(l$)
sub writecurrentline(p%)
sub ProcessKeyword

strsegsize 64k

begin code

print "Stupid Little Compiler v0.01 [DOS]; Copyright (C) 1998 by Rowan Crowe\n\n"
cmd$ = cmdline : cmd$ = ltrim(cmd$) : cmd$ = rtrim(cmd$)
cmd$ = lcase(cmd$)

if cmd$ = "" then
  print "usage: slc <sourcefile>\n"
  end
endif

stkptr% = 0
vartype% = %VAR_GLOBAL
localvartable$ = ""
globalvartable$ = ""

f$ = cmd$ + ".slc"
ihandle% = fopen(f$, readonly)
f$ = cmd$ + ".asm"
ohandle% = fcreate(f$, archive)

call wo(".model\tsmall,basic\ncode\tsegment word public\nassume\tcs:code\norg\t100h\nstart:\n")

f% = feof(ihandle%)
while f% = FALSE
  curline% = curline% + 1
  thisline.valdef% = FALSE
  thisline.global% = FALSE
  finput(ihandle%, l$)
  l$ = ltrim(l$) : l$ = rtrim(l$)
  if l$ <> "" then
    curline$ = l$
    t$ = "000" + str(curline%)
    fprint(ohandle%, "; " + right(t$, 4) + "  " + l$ + "\n")
    call Evaluate(l$)
  endif
  f% = feof(ihandle%)
wend
fclose(ihandle%)

call wo("code\tends\nend start\n")
fclose(ohandle%)

if braceptr% < 0 then
  print "warning: brace mismatch: too many '}' close braces\n"
  end
endif
if braceptr% > 0 then
  print "warning: brace mismatch: too many '{' open braces\n"
  end
endif

print "processed " + curline% + " line(s) successfully, outfile is '" + f$ + "'\n"

#ifdef DEBUG
  s% = unusedstack
  print "unused stack space=" + s% + "\n"
#endif
end


sub Evaluate(l$)
call Parse(l$)
#ifdef DEBUG
  for i% = 0 to bpp%
    print bp$[i%] + "["
    select case bpt%[i%]
      case %NUMBER
        print "NUMBER"
      case %OPERATOR
        print "OPERATOR"
      case %VARIABLE
        print "VARIABLE"
      case %BRACKET_OPEN
        print "BRACKET_OPEN"
      case %BRACKET_CLOSE
        print "BRACKET_CLOSE"
      case %COMMA
        print "COMMA"
      case %FUNCTION
        print "FUNCTION"
      case %ARRAY_BRACKET
        print "ARRAY_BRACKET"
      case %POINTER
        print "POINTER"
      case %KEYWORD
        print "KEYWORD"
      case %OPENBRACE
        print "OPENBRACE"
      case %CLOSEBRACE
        print "CLOSEBRACE"
      case %STRING_CONSTANT
        print "STRINGCONSTANT:" + bp$[i%]
      case else
        print "unknown:" + bpt%[i%]
    end select
    print "]"
  next
  print "\n"
#endif

bpptr% = 0

while bpptr% <= bpp%
  if bpt%[bpptr%] = %KEYWORD then
    call ProcessKeyword
  else
    call Logical
  endif
wend
end sub


#preserve
sub Logical
call Compare
if bpptr% > bpp% then exit sub
r% = sinstr(bp$[bpptr%], "&|")
while r% <> 0
  select case bp$[bpptr%]
    case "|"
      bpptr% = bpptr% + 1
      call wo("\tpush\tax\n")
      call Compare
      call wo("\tpop\tcx\n\tor\tax,cx\n")
    case "&"
      bpptr% = bpptr% + 1
      call wo("\tpush\tax\n")
      call Compare
      call wo("\tpop\tcx\n\tand\tax,cx\n")
  end select
  r% = sinstr(bp$[bpptr%], "&|")
  if bpptr% > bpp% then exit while
wend
end sub


#preserve
sub Compare
call AddSubtract
if bpptr% > bpp% then exit sub
r% = sinstr(bp$[bpptr%], "!<=>")
while r% <> 0
  select case bp$[bpptr%]
    case "=="
      bpptr% = bpptr% + 1
      call wo("\tpush\tax\n")
      call AddSubtract
      call wo("\tpop\tcx\n\tcmp\tax,cx\n\tmov\tax,0\n\tsbb\tax,0\n")
    case "!="
      bpptr% = bpptr% + 1
      call wo("\tpush\tax\n")
      call AddSubtract
      call wo("\tpop\tcx\n\tcmp\tax,cx\n\tmov\tax,0FFFFh\n\tadc\tax,0\n")
    case "<"
      bpptr% = bpptr% + 1
      call wo("\tpush\tax\n")
      call AddSubtract
      call wo("\tpop\tcx\n\tcmp\tax,cx\n\tmov\tax,0FFFFh\n")
      t$ = "LL" + locallabel% : locallabel% = locallabel% + 1
      t1$ = "\tjb\t" + t$ + "\n"
      call wo(t1$)
      call wo("\tinc\tax\n")
      t1$ = t$ + ":\n"
      call wo(t1$)
    case ">"
      bpptr% = bpptr% + 1
      call wo("\tpush\tax\n")
      call AddSubtract
      call wo("\tpop\tcx\n\tcmp\tax,cx\n\tmov\tax,0FFFFh\n")
      t$ = "LL" + locallabel% : locallabel% = locallabel% + 1
      t1$ = "\tja\t" + t$ + "\n"
      call wo(t1$)
      call wo("\tinc\tax\n")
      t1$ = t$ + ":\n"
      call wo(t1$)
    case "<="
      bpptr% = bpptr% + 1
      call wo("\tpush\tax\n")
      call AddSubtract
      call wo("\tpop\tcx\n\tcmp\tax,cx\n\tmov\tax,0FFFFh\n")
      t$ = "LL" + locallabel% : locallabel% = locallabel% + 1
      t1$ = "\tjbe\t" + t$ + "\n"
      call wo(t1$)
      call wo("\tinc\tax\n")
      t1$ = t$ + ":\n"
      call wo(t1$)
    case "=>"
      bpptr% = bpptr% + 1
      call wo("\tpush\tax\n")
      call AddSubtract
      call wo("\tpop\tcx\n\tcmp\tax,cx\n\tmov\tax,0FFFFh\n")
      t$ = "LL" + locallabel% : locallabel% = locallabel% + 1
      t1$ = "\tjae\t" + t$ + "\n"
      call wo(t1$)
      call wo("\tinc\tax\n")
      t1$ = t$ + ":\n"
      call wo(t1$)
  end select
  if bpptr% > bpp% then exit while
  r% = sinstr(bp$[bpptr%], "<=>")
wend
end sub


#preserve
sub AddSubtract
call DivideMultiply
if bpptr% > bpp% then
  exit sub
endif
r% = sinstr(bp$[bpptr%], "+-")
while r% <> 0
  if bp$[bpptr%] = "+" then
    bpptr% = bpptr% + 1
    call wo("\tpush\tax\n")
    call DivideMultiply
    call wo("\tpop\tcx\n\tadd\tax,cx\n")
  else
    bpptr% = bpptr% + 1
    call wo("\tpush\tax\n")
    call DivideMultiply
    call wo("\tmov\tcx,ax\n\tpop\tax\n\tsub\tax,cx\n")
  endif
  if bpptr% > bpp% then exit while
  r% = sinstr(bp$[bpptr%], "+-")
wend

end sub


#preserve
sub DivideMultiply
call Bracket
if bpptr% > bpp% then
  exit sub
endif
r% = sinstr(bp$[bpptr%], "*/")
while r% <> 0
  if bp$[bpptr%] = "*" then
    bpptr% = bpptr% + 1
    call wo("\tpush\tax\n")
    call Bracket
    call wo("\tmov\tcx,ax\n\tpop\tax\n\tmul\tcx\n")
  else
    bpptr% = bpptr% + 1
    call wo("\tpush\tax\n")
    call Bracket
    call wo("\tmov\tcx,ax\n\tpop\tax\n\tcwd\n\tdiv\tcx\n")
  endif
  if bpptr% > bpp% then exit while
  r% = sinstr(bp$[bpptr%], "*/")
wend
end sub


#preserve
sub Bracket
if bpptr% > bpp% then exit sub

negjump:

select case bpt%[bpptr%]
  case %COMMENT
    ' ignore rest of line
    bpptr% = bpp% + 2 ' clear the end of line
    exit sub
  case %STRING_CONSTANT
    l% = len(bp$[bpptr%])
    sc$ = "SC" + str(strconstlabel%) + " db '"
    for i% = 1 to l%
      c% = sbyte(bp$[bpptr%], i%)
      select case c%
        case 39 ' '
          sc$ = sc$ + "',39,'"
        case 92 ' \
          i% = i% + 1
          d% = sbyte(bp$[bpptr%], i%)
          select case d%
            case 110  'n
              sc$ = sc$ + "',13,10,'"
            case 48  ' 0
                sc$ = sc$ + "',0,'"
            case 92  ' \
                sc$ = sc$ + "',47,'"
            case 116  ' t
                sc$ = sc$ + "',9,'"
          end select
        case else
          sc$ = sc$ + chr(c%)
      end select
    next
    strconstbuf$ = strconstbuf$ + sc$ + "',0\n"
    tw$ = "\tmov\tax,offset SC" + str(strconstlabel%) + "\n"
    call wo(tw$)
    strconstlabel% = strconstlabel% + 1
    bpptr% = bpptr% + 1

  case %NUMBER
    t$ = bp$[bpptr%]
    if negflag% = TRUE then
      t$ = "-" + t$
      negflag% = FALSE
    endif
    tw$ = "\tmov\tax," + t$ + "\n"
    call wo(tw$)
    bpptr% = bpptr% + 1
  case %FUNCTION
    fn% = bpptr%
    bpptr% = bpptr% + 1
    if bp$[bpptr%] <> "(" then
      call writecurrentline(bpi%[bpptr%])
      print "- syntax error: expected '(' after function name ('" + bp$[bpptr%] + "' found)\n"
      end
    endif
    bpptr% = bpptr% + 1
    sp% = 0
    if bp$[bpptr%] <> ")" then
      found% = FALSE
      while found% = FALSE
        call Logical
        if bp$[bpptr%] = ")" then found% = TRUE : exit while
        if bp$[bpptr%] = "," then
          bpptr% = bpptr% + 1
          if thisline.valdef% = FALSE then
            sp% = sp% + 2
            call wo("\tpush\tax\n")
          endif
        endif
        if bpptr% > bpp% then exit while
      wend
      if found% = FALSE then
        call writecurrentline(bpi%[bpptr%])
        print "- syntax error: expected closing ')'\n"
        end
      endif
      call wo("\tpush\tax\n")
      sp% = sp% + 2
    endif

    t$ = "\tcall\t_" + bp$[fn%] + "\n"
    call wo(t$)
'    if sp% <> 0 then
'      t$ = "\tadd\tsp," + str(sp%) + "\n"
'      call wo(t$)
'    endif
    bpptr% = bpptr% + 1
  case %POINTER
    bpptr% = bpptr% + 1
    if bpt%[bpptr%] = %BRACKET_OPEN then
      bpptr% = bpptr% + 1
      call Logical
      if bpt%[bpptr%] <> %BRACKET_CLOSE then
        call writecurrentline(bpi%[bpptr%])
        print "- syntax error: expected closing ')'\n"
        end
      endif
      bpptr1% = bpptr% + 1
      if bp$[bpptr1%] = "=" then
      ' it's an assignment
        t$ = lcase(bp$[bpptr%]) + ""
        ptr% = instr(localvartable$, t$)
        if ptr% = 0 then
          call writecurrentline(bpi%[bpptr%])
          print "- variable '" + bp$[bpptr%] + "' undefined\n"
          end
        endif

        ptr% = ptr% - 1
        vs% = sbyte(localvartable$, ptr%)

        call wo("\tpush\tax\n")
        bpptr% = bpptr% + 2
        call Logical
        call wo("\tpop\tsi\n")
        select case vs%
          case 98  ' b
            call wo("\tmov\tbyte ptr [si],al\n")
          case 119 ' w
            call wo("\tmov\tword ptr [si],ax\n")
        end select
        exit sub  ' end of line
      endif
      call wo("\tmov\tsi,ax\n\tmov\tax,word ptr [si]\n")
    else
      t$ = lcase(bp$[bpptr%]) + ""
      ptr% = instr(localvartable$, t$)
      if ptr% = 0 then
        call writecurrentline(bpi%[bpptr%])
        print "- variable '" + bp$[bpptr%] + "' undefined\n"
        end
      endif
      ptr% = ptr% - 1
      vs% = sbyte(localvartable$, ptr%)
      bpptr1% = bpptr% + 1
      if bp$[bpptr1%] = "=" then
        vn% = bpptr%
      ' it's an assignment
        bpptr% = bpptr% + 2
        call Logical
        t$ = "\tmov\tsi,word ptr [" + bp$[vn%] + "]\n"
        call wo(t$)
        select case vs%
          case 98  ' b
            call wo("\tmov\tbyte ptr [si],al\n")
          case 119 ' w
            call wo("\tmov\tword ptr [si],ax\n")
        end select
        exit sub  ' end of line
      endif
      tw$ = "\tmov\tsi,word ptr [" + bp$[bpptr%] + "]\n"
      call wo(tw$)
      select case vs%
        case 98  ' b
          call wo("\tmov\tal,byte ptr [si]\n\tmov\tah,0\n")
        case 119 ' w
          call wo("\tmov\tax,word ptr [si]\n")
      end select
    endif
    bpptr% = bpptr% + 1
  case %VARIABLE
    t$ = lcase(bp$[bpptr%]) + ""
    ptr% = instr(localvartable$, t$)
    if ptr% = 0 then
      call writecurrentline(bpi%[bpptr%])
      print "- variable '" + bp$[bpptr%] + "' undefined\n"
      end
    endif
    ptr% = ptr% - 1
    vs% = sbyte(localvartable$, ptr%)
    ptr% = ptr% - 1
    vt% = sbyte(localvartable$, ptr%)
    vn% = bpptr%
    t% = bpptr% + 1
    arrayflag% = FALSE
    if bpt%[t%] = %ARRAY_BRACKET then
      arrayflag% = TRUE
      bpptr% = bpptr% + 1
      bp$[bpptr%] = "("
      bpt%[bpptr%] = %BRACKET_OPEN
      bpptr% = bpptr% + 1
      found% = FALSE
      for i% = bpptr% to bpp%
        if bp$[i%] = "]" then
          found% = TRUE
          exit for
        endif
      next
      if found% = FALSE then
        call writecurrentline(bpi%[bpp%])
        print "- syntax error: expected closing ']'\n"
        end
      endif
      bp$[i%] = ")"
      bpt%[i%] = %BRACKET_CLOSE

      call Logical
'      bpptr% = bpptr% + 1

      call wo("\tmov\tsi,ax\n\tadd\tsi,si\n")
      bpptr1% = bpptr% + 1
      if bp$[bpptr1%] = "=" then
        ' assignment
        call wo("\tpush\tsi\n")
        bpptr% = bpptr% + 2
        call Logical
        select case vs%
          case 98  ' b
            if vt% = 80 then  ' pointer = somevalue
              tw$ = "\tpop\tsi\n\tmov\tword ptr [" + bp$[vn%] + "+si],ax\n")
            else
              tw$ = "\tpop\tsi\n\tmov\tbyte ptr [" + bp$[vn%] + "+si],al\n")
            endif
          case 119 ' w
            tw$ = "\tpop\tsi\n\tmov\tword ptr [" + bp$[vn%] + "+si],ax\n")
        end select
        call wo(tw$)
        exit sub
      endif
    endif

    if arrayflag% = FALSE then
      bpptr1% = bpptr% + 1
      if bp$[bpptr1%] = "=" then
        bpptr% = bpptr% + 2
        call Logical
        select case vs%
          case 98  ' b
            if vt% = 80 then  ' pointer = somevalue
              tw$ = "\tmov\tword ptr [" + bp$[vn%] + "],ax\n")
            else
              tw$ = "\tmov\tbyte ptr [" + bp$[vn%] + "],al\n")
            endif
          case 119 ' w
            tw$ = "\tmov\tword ptr [" + bp$[vn%] + "],ax\n")
        end select
        call wo(tw$)
        exit sub
      endif
      select case vs%
        case 98  ' b
          if vt% = 80 then  ' raw pointer
            tw$ = "\tmov\tax,word ptr [" + bp$[bpptr%] + "]\n")
          else
            tw$ = "\tmov\tal,byte ptr [" + bp$[bpptr%] + "]\n\tmov\tah,0\n")
          endif
        case 119 ' w
          tw$ = "\tmov\tax,word ptr [" + bp$[bpptr%] + "]\n")
      end select
      call wo(tw$)
    else
      select case vs%
        case 98  ' b
          if vt% = 80 then  ' raw pointer
            tw$ = "\tmov\tax,word ptr [" + bp$[vn%] + "+si]\n")
          else
            tw$ = "\tmov\tal,byte ptr [" + bp$[vn%] + "+si]\n\tmov\tah,0\n")
          endif
        case 119 ' w
          tw$ = "\tmov\tax,word ptr [" + bp$[vn%] + "+si]\n")
      end select
      call wo(tw$)
    endif
    bpptr% = bpptr% + 1
  case %COMMA
    call wo("\tpush\tax\n")
    bpptr% = bpptr% + 1
  case %BRACKET_CLOSE
    bpptr% = bpptr% + 1
  case %BRACKET_OPEN
    bpptr% = bpptr% + 1
    call Logical
    if bpt%[bpptr%] <> %BRACKET_CLOSE then
      call writecurrentline(bpi%[bpptr%])
      print "- syntax error: expected closing ')'\n"
      end
    endif
    bpptr% = bpptr% + 1
  case %OPENBRACE
    if vartype% = %VAR_FUNCPARM then
      call wo("\n")
      vartype% = %VAR_LOCAL
    endif
    bpptr% = bpptr% + 1
  case %CLOSEBRACE
    select case stk%[stkptr%]
      case %STK_IF
        t$ = "J" + str(stklabelend%[stkptr%]) + ":\n"
        call wo(t$)
        stkptr% = stkptr% - 1
      case %STK_REPEAT
        ' nothing
      case %STK_WHILE
        t$ = "\tjmp\tJ" + str(stklabelstart%[stkptr%]) + "\nJ" + str(stklabelend%[stkptr%]) + ":\n"
        call wo(t$)
        stkptr% = stkptr% - 1
      case %STK_FUNCTION
        t$ = "J" + str(stklabelend%[stkptr%]) + ":\n\tret\n" + stkp$[stkptr%] + "\tendp\n"
        call wo(t$)
        call wo(strconstbuf$)
        strconstbuf$ = ""
        stkptr% = stkptr% - 1
        vartype% = %VAR_GLOBAL
      case else
        call writecurrentline(bpi%[bpptr%])
        print "- syntax error: unknown block type at close\n"
        end
    end select
    bpptr% = bpptr% + 1
  case else
    ' handle negative numbers
    if bp$[bpptr%] = "-" then
      if negflag% = FALSE then
        bpptr% = bpptr% + 1
        negflag% = TRUE
        goto negjump
      else
        ' too many '-'s
        call writecurrentline(bpi%[bpptr%])
        print "- syntax error: unexpected token '" + bp$[bpptr%] + "' (too many negates)\n"
       end
      endif
    else
      call writecurrentline(bpi%[bpptr%])
'      t% = bpptr% - 1
'      if t% => 0 then
'        t$ = bp$[t%]
'      else
'        t$ = "<SOL>"
'      endif
      print "- syntax error: unexpected token '" + bp$[bpptr%] + "'\n"
      ' after '" + t$ + "'\n"
      end
    endif
end select

end sub


sub Parse(l$)
bpp% = 0

if l$ = "" then exit sub
l$ = l$ + ")"
p$ = ""
lt% = len(l$)
for i% = 1 to lt%

  c% = sbyte(l$, i%)
'  print i% + ":" + chr(c%) + "\n"
  bpi%[bpp%] = i%
  select case c%
    case 32, 43, 45, 47, 42, 60, 61, 62, 40, 41, 44, 38, 124, 33, 91, 93, 123, 125, 34, 35
      ' +-/*<=>(),&|![]{}"#
      if p$ <> "" then
        p$ = lcase(p$)
        bp$[bpp%] = p$
        t% = asc(p$)
        p$ = ""
        if t% > 95 then
          if t% < 123 then
            bpt%[bpp%] = %VARIABLE
            tbp$ = "" + bp$[bpp%] + ""
            ptr% = instr("ifrepeatuntilwhilevoidcharintreturnasmglobal", tbp$)
            if ptr% <> 0 then
'              print "keyword tbp$='" + tbp$ + "' ptr%=" + ptr% + "\n"
              bpt%[bpp%] = %KEYWORD
            endif
          endif
        endif
        if t% > 47 then
          if t% < 58 then
            bpt%[bpp%] = %NUMBER
          endif
        endif

        bpp% = bpp% + 1
      endif

      bp$[bpp%] = chr(c%)
      t% = sbyte(l$, i%)

      select case t%
        case 123
          bpt%[bpp%] = %OPENBRACE
          braceptr% = braceptr% + 1
        case 125
          bpt%[bpp%] = %CLOSEBRACE
          braceptr% = braceptr% - 1
        case 91, 93
          bpt%[bpp%] = %ARRAY_BRACKET
        case 43, 45, 47, 38, 124, 33
          bpt%[bpp%] = %OPERATOR
        case 42  ' *
          bpt%[bpp%] = %OPERATOR
          bpp_1% = bpp% - 1
          if bpt%[bpp_1%] = %OPERATOR then bpt%[bpp%] = %POINTER
          if bpt%[bpp_1%] = %COMMA then bpt%[bpp%] = %POINTER
          if bpt%[bpp_1%] = %BRACKET_OPEN then bpt%[bpp%] = %POINTER
          if bpt%[bpp_1%] = %KEYWORD then bpt%[bpp%] = %POINTER
          ' this is to allow char *p and int *p
          if bpp% = 0 then bpt%[0] = %POINTER
        case 60  ' <
          bpt%[bpp%] = %OPERATOR
        case 61  ' =
          bpt%[bpp%] = %OPERATOR
          bpp_1% = bpp% - 1
          if bp$[bpp_1%] = "<" then
            bpp% = bpp% - 1
            bp$[bpp%] = "<="
          endif
          if bp$[bpp_1%] = "!" then
            bpp% = bpp% - 1
            bp$[bpp%] = "!="
          endif
          if bp$[bpp_1%] = "=" then
            bpp% = bpp% - 1
            bp$[bpp%] = "=="
          endif
        case 62  ' >
          bpt%[bpp%] = %OPERATOR
          bpp_1% = bpp% - 1
          if bp$[bpp_1%] = "=" then
            bpp% = bpp% - 1
            bp$[bpp%] = "=>"
          endif
        case 40
          bpt%[bpp%] = %BRACKET_OPEN
          bpp_1% = bpp% - 1
          if bpt%[bpp_1%] = %VARIABLE then
            bpt%[bpp_1%] = %FUNCTION
          endif
        case 41
          bpt%[bpp%] = %BRACKET_CLOSE
        case 44
          bpt%[bpp%] = %COMMA
        case 32
          bpp% = bpp% - 1 ' to cancel out the add below
        case 35
          bpt%[bpp%] = %COMMENT
          exit for
        case 34
          bpt%[bpp%] = %STRING_CONSTANT
          i% = i% + 1
          j% = i%
          found% = FALSE
          while j% <= lt%
            qt% = sbyte(l$, j%)
            if qt% = 34 then found% = TRUE : exit while
            j% = j% + 1
          wend
          if found% = FALSE then
            call writecurrentline(bpi%[bpptr%])
            print "- syntax error: unterminated string constant\n"
            end
          endif
          l% = j% - i%
          bp$[bpp%] = mid(l$, i%, l%)
          i% = j%
      end select
      bpp% = bpp% + 1
'    case 32
'     ' nothing
    case else
      p$ = p$ + chr(c%)
  end select
next

bpp% = bpp% - 1
bp$[bpp%] = "<EOL>"
bpt%[bpp%] = 0
bpi%[bpp%] = i%
bpp% = bpp% - 1

end sub


sub wo(l$)
fprint(ohandle%, l$)
end sub


sub ProcessKeyword
' bp$[bpptr%] = KEYWORD
select case bp$[bpptr%]
  case "if"
    bpptr% = bpptr% + 1
    if bpptr% >= bpp% then
      call writecurrentline(bpi%[bpptr%])
      print "- syntax error: expected expression after 'if'\n"
      end
    endif
    if bpt%[bpptr%] <> %BRACKET_OPEN then
      call writecurrentline(bpi%[bpptr%])
      print "- syntax error: expected opening '(' after 'if'\n"
      end
    endif

    while bpptr% <= bpp%
      call Logical
    wend
    t$ = "\tor\tax,ax\n\tjz\tLL" + str(locallabel%) + "\n"
    call wo(t$)
    t$ = "\tjmp\tJ" + jumplabel% + "\nLL" + str(locallabel%) + ":\n"
    call wo(t$)
    stkptr% = stkptr% + 1
    stklabelend%[stkptr%] = jumplabel%
    stk%[stkptr%] = %STK_IF
    locallabel% = locallabel% + 1
    jumplabel% = jumplabel% + 1
  case "repeat"
    t$ = "J" + str(jumplabel%) + ":\n"
    call wo(t$)
    stkptr% = stkptr% + 1
    stklabelstart%[stkptr%] = jumplabel%
    jumplabel% = jumplabel% + 1
    stklabelend%[stkptr%] = jumplabel%
    jumplabel% = jumplabel% + 1
    stk%[stkptr%] = %STK_REPEAT
    bpptr% = bpptr% + 1
  case "until"
    bpptr% = bpptr% + 1
    if bpptr% => bpp% then
      call writecurrentline(bpi%[bpptr%])
      print "- syntax error: expected expression after 'until'\n"
      end
    endif
    while bpptr% <= bpp%
      call Logical
    wend
    t$ = "\tor\tax,ax\n\tjz\tLL" + str(locallabel%) + "\n"
    call wo(t$)
    t$ = "\tjmp\tJ" + stklabelstart%[stkptr%] + "\nLL" + str(locallabel%) + ":\n"
    call wo(t$)
    t$ = "J" + stklabelend%[stkptr%] + ":\n"
    call wo(t$)
    locallabel% = locallabel% + 1
    stkptr% = stkptr% - 1
  case "while"
    t$ = "J" + str(jumplabel%) + ":\n"
    call wo(t$)
    stkptr% = stkptr% + 1
    stklabelstart%[stkptr%] = jumplabel%
    jumplabel% = jumplabel% + 1
    bpptr% = bpptr% + 1
    if bpptr% => bpp% then
      call writecurrentline(bpi%[bpptr%])
      print "- syntax error: expected expression after 'while'\n"
      end
    endif
    while bpptr% <= bpp%
      call Logical
    wend
    t$ = "\tor\tax,ax\n\tjz\tLL" + str(locallabel%) + "\n"
    call wo(t$)
    t$ = "\tjmp\tJ" + str(jumplabel%) + "\nLL" + str(locallabel%) + ":\n"
    call wo(t$)
    stklabelend%[stkptr%] = jumplabel%
    stk%[stkptr%] = %STK_WHILE
    locallabel% = locallabel% + 1
    jumplabel% = jumplabel% + 1

  case "int", "char", "void"
    valdef$ = bp$[bpptr%]
    thisline.valdef% = TRUE
valdef_again:
    psz$ = "word"
    if valdef$ = "char" then psz$ = "byte"

    bpptr% = bpptr% + 1
    select case bpt%[bpptr%]
      case %POINTER
        bpptr% = bpptr% + 1
        localvartable$ = localvartable$ + "P" + left(psz$, 1) + lcase(bp$[bpptr%]) + ""
        psz$ = "word"
        goto pointer_variable
      case %VARIABLE
        localvartable$ = localvartable$ + "V" + left(psz$, 1) + lcase(bp$[bpptr%]) + ""
pointer_variable:
        select case vartype%
          case %VAR_FUNCPARM
            t$ = ", " + bp$[bpptr%] + ":" + psz$
            call wo(t$)
          case %VAR_LOCAL
            t$ = "local\t" + bp$[bpptr%] + ":" + psz$ + "\n"
            call wo(t$)
          case %VAR_GLOBAL
            if thisline.global% = TRUE then
              t$ = "public\t" + bp$[bpptr%] + "\n"
              call wo(t$)
            endif
            t$ = bp$[bpptr%] + "\tdw\t?\n"
            call wo(t$)
        end select
        bpptr% = bpptr% + 1
        if bpt%[bpptr%] = %COMMA then
'          if thisline.valdef% = TRUE then
            bpptr% = bpptr% + 1
'            if bpt%[bpptr%] = %VARIABLE then bpptr% = bpptr% - 1
'            goto valdef_again
'          endif
        endif
      case %FUNCTION
        localvartable$ = ""
        if thisline.global% = TRUE then
          t$ = "public\t _" + bp$[bpptr%] + "\n"
          call wo(t$)
        endif
        thisline.valdef% = FALSE ' can't do "int x,y,z"
        t$ = "_" + bp$[bpptr%] + "\tproc near"
        call wo(t$)
'        call wo("\tpush\tbp\n\tmov\tbp,sp\n")
        vartype% = %VAR_FUNCPARM
'        if valdef$ = "void" then
'          call wo("\n")
'          vartype% = %VAR_LOCAL
'        endif
        stkptr% = stkptr% + 1
        stk%[stkptr%] = %STK_FUNCTION
        stkp$[stkptr%] = "_" + bp$[bpptr%]
        stklabelend%[stkptr%] = jumplabel%
        funclabelend% = jumplabel%
        jumplabel% = jumplabel% + 1
        bpptr% = bpptr% + 2
      case else
        call writecurrentline(bpi%[bpptr%]
        print "- syntax error: unexpected parameter '" + bp$[bpptr%] + "'\n"
        ' after " + valdef$ + "\n"
        end
    end select
  case "return"
    bpptr% = bpptr% + 1
    if bpptr% => bpp% then
      call writecurrentline(bpi%[bpptr%])
      print "- syntax error: expected expression after 'return'\n"
      end
    endif
    while bpptr% <= bpp%
      call Logical
    wend
    t$ = "\tjmp\tJ" + funclabelend% + "\n"
    call wo(t$)
  case "asm"
    bpptr% = bpp% + 1
    ptr% = cinstr(curline$, 32)
    if ptr% <> 0 then
      t$ = mid(curline$, ptr%)
      t$ = "\t" + ltrim(t$) + "\n"
      call wo(t$)
    endif
  case "global"
    thisline.global% = TRUE
    bpptr% = bpptr% + 1
  case else
    call writecurrentline(bpi%[bpptr%])
    print "- compiler error: unknown keyword '" + bp$[bpptr%] + "'\n"
    end
end select
end sub


sub writecurrentline(p%)
print curline% + ":  "
t$ = left(curline$, p%)
l% = len(t$)
c% = sbyte(t$, l%)
if c% <> 32 then t$ = t$ + " "
print t$ + "##"
p% = p% + 1
t$ = mid(curline$, p%)
c% = asc(t$)
if c% <> 32 then print " "
print t$ + "\n"
end sub
